<?php
/**
 * BSeller Platform | B2W - Companhia Digital
 *
 * Do not edit this file if you want to update this module for future new versions.
 *
 * @category  ${MAGENTO_MODULE_NAMESPACE}
 * @package   ${MAGENTO_MODULE_NAMESPACE}_${MAGENTO_MODULE}
 *
 * @copyright Copyright (c) 2018 B2W Digital - BSeller Platform. (http://www.bseller.com.br)
 *
 * @author    Tiago Sampaio <tiago.sampaio@e-smart.com.br>
 */

namespace BitTools\SkyHub\Observer\Sales\Order\Creditmemo;

use BitTools\SkyHub\Observer\Sales\AbstractSales;
use Magento\Framework\Event\Observer;

class CancelOrderAfterRefund extends AbstractSales
{
    
    /**
     * @param Observer $observer
     */
    public function execute(Observer $observer)
    {
        /** @var \Magento\Sales\Model\Order\Creditmemo $creditmemo */
        $creditmemo = $observer->getData('creditmemo');
        
        if (!$creditmemo || !$creditmemo->getEntityId()) {
            return;
        }
        
        /** @var \Magento\Store\Model\Store $store */
        $store   = $creditmemo->getStore();
        $orderId = $creditmemo->getOrderId();
        
        $this->storeIterator->call($this->orderIntegrator, 'cancel', [$orderId], $store);
    }
}
